#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>

// Irrfahrt einer Figur auf einem 21x21-Positionsfeld. Die Figur bewegt sich mit gleicher
// Wahrscheinlichkeit nach x-rechts, x-links bzw. behaelt seinen x-Standort bei. Eben -
// falls mit gleicher Wahrscheinlichkeit bewegt sich die Figur nach x-rechts, x-links
// bzw. behaelt seinen y-Standort bei.

int spielfeld [21][21] ;
int i = 0 ;
int j = 0 ;
int xpos = 0 ;
int ypos = 0 ;
int xri = 0 ;
int yri = 0 ;
int count = 0 ;
int frequ = 1 ;
int zuege = 0 ;

// Hauptfunktion

void main()
{

	// Initiaisiserung des Zufallsgenerators

	srand (time (NULL)) ;

	clrscr () ;

	// Positionsfeld wird mit 21x21 Punkten '.' aufgebaut

	for ( i = 0 ; i < 20 ; i ++ )
	{
		for ( j = 0; j < 20 ; j ++ )
		{
			printf ( "." ) ;

		}

		printf ("\n") ;
	}

	// Positionswerte mit Null initialisieren

	gotoxy (0,0) ;
	
	for (i = 0; i< 21; i++ )
	{
		for (j = 0; j< 21; j++ )
		{
			spielfeld[i][j] = 0 ;
		}
	}

	// Startposition initialisieren

	xpos = 10 ;
	ypos = 10 ;

	// Aktuellen Startpositionswert sichern. Aktueller Wert ist 1

	spielfeld[10][10] = frequ ;

    // Irrfahrt starten

	while ( xpos-1 >= 0 && xpos+1 < 21 && ypos-1 >= 0 && ypos+1 < 21  )
	{
		// x-Richtung, y-Richtungsaenderung zurcksetzen

	    xri = 0 ;
		yri = 0 ;

		// Zufallszahl auswerten und x-Richtung bestimmen

		switch ( rand ()%3)
		{
			case 0 : xri = 0 ;
					 break ;
			case 1 : xri = -1 ;
					 break ;
			case 2 : xri = 1 ;
		}

		// Zufallszahl auswerten und y-Richtung bestimmen
        
		switch ( rand ()%3)
		{
			case 0 : yri = 0 ;
					 break ;
			case 1 : yri = -1 ;
					 break ;
			case 2 : yri = 1 ;
		}

		// Neuberechnung und Ansteuern der aktuellen Zielposition

		xpos = xpos + xri ;
		ypos = ypos + yri ;

		gotoxy ( xpos, ypos ) ;

		// Frequenz in der Zielposition (mod 10) aktualisieren 

		frequ = (spielfeld[xpos][ypos] + 1 ) % 10 ;
			
		spielfeld[xpos][ypos] = frequ ;
		
		printf ( "%i", spielfeld[xpos][ypos] ) ;

		zuege++ ;

		getch () ;
	}

    gotoxy (1,21) ;
	printf ("\nFigur hat den Spielfeldrand erreicht: %i Zuege! Ende der Irrfahrt\n", zuege ) ;
	printf ("\n    Weiter mit beliebiger Taste  ... " ) ;
    getch() ;
}